from muppet.util import group_by, concatenate


def test_group_by():
    groups = group_by(lambda x: x % 3, range(10))
    assert len(groups) == 3
    assert groups[0] == [0, 3, 6, 9]
    assert groups[1] == [1, 4, 7]
    assert groups[2] == [2, 5, 8]


def test_concatenate():
    assert concatenate([[1, 2], [3, 4]]) == [1, 2, 3, 4]
    assert concatenate([[1, [2]], [3, 4]]) == [1, [2], 3, 4]
